VERSION 5.00
Begin VB.Form frmmslot 
   Caption         =   "Mailslot"
   ClientHeight    =   2115
   ClientLeft      =   1095
   ClientTop       =   1515
   ClientWidth     =   4260
   LinkTopic       =   "Form1"
   PaletteMode     =   1  'UseZOrder
   ScaleHeight     =   2115
   ScaleWidth      =   4260
   Begin VB.Timer Timer1 
      Interval        =   100
      Left            =   3960
      Top             =   -60
   End
   Begin VB.TextBox txtMailSlotName 
      Height          =   285
      Left            =   1500
      TabIndex        =   2
      Text            =   "\\.\mailslot\demo\slot1"
      Top             =   120
      Width           =   2535
   End
   Begin VB.TextBox txtInfo 
      Height          =   1455
      Left            =   240
      MultiLine       =   -1  'True
      TabIndex        =   1
      Top             =   480
      Width           =   3795
   End
   Begin VB.CheckBox chkServer 
      Caption         =   "Server"
      Height          =   255
      Left            =   300
      TabIndex        =   0
      Top             =   120
      Value           =   1  'Checked
      Width           =   1035
   End
End
Attribute VB_Name = "frmmslot"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
' Copyright  1997 by Desaware Inc. All Rights Reserved

Private Type OVERLAPPED
        Internal As Long
        InternalHigh As Long
        offset As Long
        OffsetHigh As Long
        hEvent As Long
End Type

Private Declare Function CreateMailslot Lib "kernel32" Alias "CreateMailslotA" (ByVal lpName As String, ByVal nMaxMessageSize As Long, ByVal lReadTimeout As Long, ByVal lpSecurityAttributes As Long) As Long
Private Declare Function CloseHandle Lib "kernel32" (ByVal hObject As Long) As Long
Private Declare Function WriteFile Lib "kernel32" (ByVal hFile As Long, lpBuffer As Any, ByVal nNumberOfBytesToWrite As Long, lpNumberOfBytesWritten As Long, ByVal lpOverlapped As Long) As Long
Private Declare Function ReadFile Lib "kernel32" (ByVal hFile As Long, lpBuffer As Any, ByVal nNumberOfBytesToRead As Long, lpNumberOfBytesRead As Long, ByVal lpOverlapped As Long) As Long
Private Declare Function ReadFileAsync Lib "kernel32" (ByVal hFile As Long, lpBuffer As Any, ByVal nNumberOfBytesToRead As Long, lpNumberOfBytesRead As Long, lpOverlapped As OVERLAPPED) As Long
Private Declare Function CreateFile Lib "kernel32" Alias "CreateFileA" (ByVal lpFileName As String, ByVal dwDesiredAccess As Long, ByVal dwShareMode As Long, ByVal lpSecurityAttributes As Long, ByVal dwCreationDisposition As Long, ByVal dwFlagsAndAttributes As Long, ByVal hTemplateFile As Long) As Long
Private Declare Function GetLastError Lib "kernel32" () As Long
Private Const OPEN_EXISTING = 3
Private Const GENERIC_READ = &H80000000
Private Const GENERIC_WRITE = &H40000000
Private Const GENERIC_EXECUTE = &H20000000
Private Const GENERIC_ALL = &H10000000
Private Const INVALID_HANDLE_VALUE = -1
Private Const FILE_SHARE_READ = &H1
Private Const FILE_SHARE_WRITE = &H2
Private Const FILE_ATTRIBUTE_NORMAL = &H80

Dim IsServer As Boolean
Dim mshandle&   ' Mailslot handle

Private Sub chkServer_Click()
    SetServerState chkServer.Value
End Sub

Private Sub Form_Load()
    mshandle = INVALID_HANDLE_VALUE
    SetServerState chkServer.Value
End Sub

Private Sub SetServerState(ByVal newstate)
    If mshandle <> INVALID_HANDLE_VALUE Then
        Call CloseHandle(mshandle)
        mshandle = 0
    End If
    txtInfo.Text = ""
    IsServer = newstate
    If IsServer Then
        ' It's a server
        mshandle = CreateMailslot(txtMailSlotName.Text, 0, 0, 0)
    Else
        ' Open as a client
        mshandle = CreateFile(txtMailSlotName.Text, GENERIC_WRITE, FILE_SHARE_READ, 0, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, 0)
    End If
    If mshandle = INVALID_HANDLE_VALUE Then
        MsgBox "Unable to open mailslot"
    End If
End Sub

Private Sub Form_Unload(Cancel As Integer)
    If mshandle <> INVALID_HANDLE_VALUE Then
        Call CloseHandle(mshandle)
        mshandle = 0
    End If

End Sub

Private Sub Timer1_Timer()
    Dim res&
    Dim inchar%
    Dim bytesread&
    If IsServer And mshandle <> INVALID_HANDLE_VALUE Then
        ' It's a server, so read a byte and add it to
        ' the text box
        res = ReadFile(mshandle, inchar, 2, bytesread&, 0)
        If res And bytesread = 2 Then
            txtInfo.Text = txtInfo.Text & Chr$(inchar)
        End If
    End If
End Sub

Private Sub txtInfo_KeyPress(KeyAscii As Integer)
    Dim res&
    Dim byteswritten&
    If (Not IsServer) And mshandle <> INVALID_HANDLE_VALUE Then
        ' It's a client, send the message
        res = WriteFile(mshandle, KeyAscii, 2, byteswritten, 0)
        KeyAscii = 0
    End If
End Sub
