Attribute VB_Name = "DEVVIEW1"
Option Explicit
' Copyright  1997 by Desaware Inc. All Rights Reserved

#If Win32 Then
Declare Function GetDeviceCaps Lib "gdi32" (ByVal hDC As Long, ByVal nIndex As Long) As Long
#Else
Declare Function GetDeviceCaps% Lib "GDI" (ByVal hDC%, ByVal nIndex%)
#End If

' Global Constants used in devview
Global Const DRIVERVERSION = 0
Global Const TECHNOLOGY = 2
Global Const HORZSIZE = 4
Global Const VERTSIZE = 6
Global Const HORZRES = 8
Global Const VERTRES = 10
Global Const BITSPIXEL = 12
Global Const PLANES = 14
Global Const NUMBRUSHES = 16
Global Const NUMPENS = 18
Global Const NUMMARKERS = 20
Global Const NUMFONTS = 22
Global Const NUMCOLORS = 24
Global Const PDEVICESIZE = 26
Global Const CURVECAPS = 28
Global Const LINECAPS = 30
Global Const POLYGONALCAPS = 32
Global Const TEXTCAPS = 34
Global Const CLIPCAPS = 36
Global Const RASTERCAPS = 38
Global Const ASPECTX = 40
Global Const ASPECTY = 42
Global Const ASPECTXY = 44
Global Const LOGPIXELSX = 88
Global Const LOGPIXELSY = 90
Global Const SIZEPALETTE = 104
Global Const NUMRESERVED = 106
Global Const COLORRES = 108
Global Const DT_PLOTTER = 0
Global Const DT_RASDISPLAY = 1
Global Const DT_RASPRINTER = 2
Global Const DT_RASCAMERA = 3
Global Const DT_CHARSTREAM = 4
Global Const DT_METAFILE = 5
Global Const DT_DISPFILE = 6
Global Const CC_NONE = 0
Global Const CC_CIRCLES = 1
Global Const CC_PIE = 2
Global Const CC_CHORD = 4
Global Const CC_ELLIPSES = 8
Global Const CC_WIDE = 16
Global Const CC_STYLED = 32
Global Const CC_WIDESTYLED = 64
Global Const CC_INTERIORS = 128
Global Const LC_NONE = 0
Global Const LC_POLYLINE = 2
Global Const LC_MARKER = 4
Global Const LC_POLYMARKER = 8
Global Const LC_WIDE = 16
Global Const LC_STYLED = 32
Global Const LC_WIDESTYLED = 64
Global Const LC_INTERIORS = 128
Global Const PC_NONE = 0
Global Const PC_POLYGON = 1
Global Const PC_RECTANGLE = 2
Global Const PC_WINDPOLYGON = 4
Global Const PC_TRAPEZOID = 4
Global Const PC_SCANLINE = 8
Global Const PC_WIDE = 16
Global Const PC_STYLED = 32
Global Const PC_WIDESTYLED = 64
Global Const PC_INTERIORS = 128
Global Const CP_NONE = 0
Global Const CP_RECTANGLE = 1
Global Const TC_OP_CHARACTER = &H1
Global Const TC_OP_STROKE = &H2
Global Const TC_CP_STROKE = &H4
Global Const TC_CR_90 = &H8
Global Const TC_CR_ANY = &H10
Global Const TC_SF_X_YINDEP = &H20
Global Const TC_SA_DOUBLE = &H40
Global Const TC_SA_INTEGER = &H80
Global Const TC_SA_CONTIN = &H100
Global Const TC_EA_DOUBLE = &H200
Global Const TC_IA_ABLE = &H400
Global Const TC_UA_ABLE = &H800
Global Const TC_SO_ABLE = &H1000
Global Const TC_RA_ABLE = &H2000
Global Const TC_VA_ABLE = &H4000
Global Const TC_RESERVED = &H8000
Global Const RC_BITBLT = 1
Global Const RC_BANDING = 2
Global Const RC_SCALING = 4
Global Const RC_BITMAP64 = 8
Global Const RC_GDI20_OUTPUT = &H10
Global Const RC_DI_BITMAP = &H80
Global Const RC_PALETTE = &H100
Global Const RC_DIBTODEV = &H200
Global Const RC_BIGFONT = &H400
Global Const RC_STRETCHBLT = &H800
Global Const RC_FLOODFILL = &H1000
Global Const RC_STRETCHDIB = &H2000
Global Const PC_RESERVED = &H1
Global Const PC_EXPLICIT = &H2
Global Const PC_NOCOLLAPSE = &H4

