VERSION 5.00
Begin VB.Form frmViewport 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Viewport Example"
   ClientHeight    =   4410
   ClientLeft      =   1380
   ClientTop       =   2040
   ClientWidth     =   7920
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   PaletteMode     =   1  'UseZOrder
   ScaleHeight     =   294
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   528
   Begin VB.CommandButton cmdSettings 
      Caption         =   "&Settings..."
      Default         =   -1  'True
      Height          =   495
      Left            =   3840
      TabIndex        =   4
      Top             =   3840
      Width           =   1095
   End
   Begin VB.TextBox txtRotate 
      Alignment       =   1  'Right Justify
      Height          =   285
      Left            =   900
      MaxLength       =   3
      TabIndex        =   3
      Text            =   "0"
      Top             =   3960
      Visible         =   0   'False
      Width           =   435
   End
   Begin VB.CommandButton cmdExit 
      Cancel          =   -1  'True
      Caption         =   "E&xit"
      Height          =   495
      Left            =   6600
      TabIndex        =   1
      Top             =   3840
      Width           =   1095
   End
   Begin VB.PictureBox pctScreen 
      DrawMode        =   7  'Invert
      DrawStyle       =   2  'Dot
      FillColor       =   &H00C0C0C0&
      ForeColor       =   &H000000FF&
      Height          =   3615
      Left            =   60
      ScaleHeight     =   239
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   510
      TabIndex        =   0
      TabStop         =   0   'False
      Top             =   120
      Width           =   7680
      Begin VB.PictureBox Picture1 
         Height          =   855
         Left            =   6420
         ScaleHeight     =   825
         ScaleWidth      =   1125
         TabIndex        =   5
         Top             =   180
         Width           =   1155
         Begin VB.Line Line3 
            BorderColor     =   &H00FF0000&
            X1              =   240
            X2              =   120
            Y1              =   480
            Y2              =   600
         End
         Begin VB.Line Line2 
            BorderColor     =   &H00FF0000&
            X1              =   120
            X2              =   240
            Y1              =   480
            Y2              =   600
         End
         Begin VB.Label Label2 
            Caption         =   "Window Origin"
            Height          =   435
            Left            =   420
            TabIndex        =   7
            Top             =   420
            Width           =   615
            WordWrap        =   -1  'True
         End
         Begin VB.Line Line1 
            BorderColor     =   &H00FFFF00&
            BorderWidth     =   2
            X1              =   60
            X2              =   300
            Y1              =   240
            Y2              =   240
         End
         Begin VB.Label Label1 
            Caption         =   "Viewport"
            Height          =   255
            Left            =   420
            TabIndex        =   6
            Top             =   120
            Width           =   675
         End
      End
   End
   Begin VB.Label lblRotate 
      Caption         =   "Rotate:"
      Height          =   255
      Left            =   240
      TabIndex        =   2
      Top             =   3990
      Visible         =   0   'False
      Width           =   615
   End
End
Attribute VB_Name = "frmViewport"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' Viewport example
' Copyright  1997 by Desaware Inc. All Rights Reserved

Option Explicit

Dim dummy&
Public dviewX1!, dviewX2!, dviewY1!, dviewY2! ' anchors for the viewport drag
Public savedDC&, RotAngle%
Dim mySize As SIZE, myPoint As POINTAPI
Public viewOrgX&, viewOrgY&, viewExtX&, viewExtY&
Public WinOrgX&, WinOrgY&, WinExtX&, WinExtY&
Public RectX1&, RectY1&, RectX2&, RectY2&
'**********************************
'**  Type Definitions:

#If Win32 Then
Private Type XFORM
        eM11 As Single
        eM12 As Single
        eM21 As Single
        eM22 As Single
        eDx As Single
        eDy As Single
End Type

Private Type SIZE
    cx As Long
    cy As Long
End Type

Private Type POINTAPI
    X As Long
    Y As Long
End Type
Private Type RECT
    Left As Long
    Top As Long
    Right As Long
    Bottom As Long
End Type
Const PS_SOLID& = 0

'**********************************
'**  Function Declarations:

Private Declare Function LineTo& Lib "gdi32" (ByVal hdc As Long, ByVal X2 As Long, ByVal Y2 As Long)
Private Declare Function MoveToEx& Lib "gdi32" (ByVal hdc As Long, ByVal X As Long, ByVal Y As Long, oldPoint As POINTAPI)
Private Declare Function Rectangle& Lib "gdi32" (ByVal hdc As Long, ByVal X1 As Long, ByVal Y1 As Long, ByVal X2 As Long, ByVal Y2 As Long)
Private Declare Function SetWorldTransform& Lib "gdi32" (ByVal hdc As Long, lpXform As XFORM)
Private Declare Function ModifyWorldTransform& Lib "gdi32" (ByVal hdc As Long, lpXform As XFORM, ByVal iMode As Long)
Private Declare Function GetWorldTransform& Lib "gdi32" (ByVal hdc As Long, lpXform As XFORM)
Private Declare Function SetGraphicsMode& Lib "gdi32" (ByVal hdc As Long, ByVal iMode As Long)
Private Declare Function SetMapMode& Lib "gdi32" (ByVal hdc As Long, ByVal nMapMode As Long)
Private Declare Function LPtoDP& Lib "gdi32" (ByVal hdc As Long, lpPoint As POINTAPI, ByVal nCount As Long)
Private Declare Function DPtoLP& Lib "gdi32" (ByVal hdc As Long, lpPoint As POINTAPI, ByVal nCount As Long)
Private Declare Function GetViewportExtEx& Lib "gdi32" (ByVal hdc As Long, lpSize As SIZE)
Private Declare Function GetViewportOrgEx& Lib "gdi32" (ByVal hdc As Long, lpPoint As POINTAPI)
Private Declare Function SetViewportExtEx& Lib "gdi32" (ByVal hdc As Long, ByVal nX As Long, ByVal nY As Long, lpSize As SIZE)
Private Declare Function ScaleViewportExtEx& Lib "gdi32" (ByVal hdc As Long, ByVal nXnum As Long, ByVal nXdenom As Long, ByVal nYnum As Long, ByVal nYdenom As Long, lpSize As SIZE)
Private Declare Function SetViewportOrgEx& Lib "gdi32" (ByVal hdc As Long, ByVal nX As Long, ByVal nY As Long, lpPoint As POINTAPI)
Private Declare Function Ellipse& Lib "gdi32" (ByVal hdc As Long, ByVal X1 As Long, ByVal Y1 As Long, ByVal X2 As Long, ByVal Y2 As Long)
Private Declare Function SetWindowExtEx& Lib "gdi32" (ByVal hdc As Long, ByVal nX As Long, ByVal nY As Long, lpSize As SIZE)
Private Declare Function SetWindowOrgEx& Lib "gdi32" (ByVal hdc As Long, ByVal nX As Long, ByVal nY As Long, lpPoint As POINTAPI)
Private Declare Function GetWindowExtEx& Lib "gdi32" (ByVal hdc As Long, lpSize As SIZE)
Private Declare Function GetWindowOrgEx& Lib "gdi32" (ByVal hdc As Long, lpPoint As POINTAPI)
Private Declare Function CreatePen& Lib "gdi32" (ByVal nPenStyle As Long, ByVal nWidth As Long, ByVal crColor As Long)
Private Declare Function SelectObject& Lib "gdi32" (ByVal hdc As Long, ByVal hObject As Long)
Private Declare Function DeleteObject& Lib "gdi32" (ByVal hObject As Long)
Private Declare Function SaveDC& Lib "gdi32" (ByVal hdc As Long)
Private Declare Function RestoreDC& Lib "gdi32" (ByVal hdc As Long, ByVal nSavedDC As Long)
Private Declare Function ClipCursor& Lib "user32" (lpRect As RECT)
Private Declare Function ClipCursorBynum& Lib "user32" Alias "ClipCursor" (ByVal lpRect As Long)
Private Declare Function ClientToScreen& Lib "user32" (ByVal hWnd As Long, lpPoint As POINTAPI)
Private Declare Function SetROP2& Lib "gdi32" (ByVal hdc As Long, ByVal nDrawMode As Long)
Const GM_ADVANCED& = 2
Const MWT_IDENTITY& = 1
Const MM_ANISOTROPIC& = 8
Const MM_HIENGLISH& = 5
Const MM_HIMETRIC& = 3
Const MM_ISOTROPIC& = 7
Const R2_COPYPEN& = 13
Private Type OSVERSIONINFO
        dwOSVersionInfoSize As Long
        dwMajorVersion As Long
        dwMinorVersion As Long
        dwBuildNumber As Long
        dwPlatformId As Long
        szCSDVersion As String * 128
End Type

Const VER_PLATFORM_WIN32_NT& = 2
Const VER_PLATFORM_WIN32_WINDOWS& = 1
Private Declare Function GetVersionEx& Lib "kernel32" Alias "GetVersionExA" (lpVersionInformation As OSVERSIONINFO)
#End If 'WIN32

Private Sub cmdExit_Click()
    Unload Me
End Sub


Private Sub cmdSettings_Click()
    frmSettings.Show 1
End Sub

Private Sub Form_Load()
    Dim myVer As OSVERSIONINFO
    myVer.dwOSVersionInfoSize = 148
    dummy& = GetVersionEx&(myVer) 'Get all the version info
    If myVer.dwPlatformId = VER_PLATFORM_WIN32_NT Then
        txtRotate.Visible = True
        lblRotate.Visible = True
    End If
'Set the default values for all the variables controlling the painting:
    'Viewport
    viewOrgX& = 200&
    viewOrgY& = 75&
    viewExtX& = 100&
    viewExtY& = 100&
    
    'Logical Window
    WinOrgX& = 0
    WinOrgY& = 0
    WinExtX& = 100
    WinExtY& = 100
    
    'Rectangle & Ellipse Dimensions
    RectX1& = 0
    RectY1& = 0
    RectX2& = 100
    RectY2& = 100
    
End Sub


Private Sub pctScreen_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
    Dim clipR As RECT, clipP As POINTAPI
    If Button And vbLeftButton Then
        'The first corner of the rectangle is recorded in the viewX1
        'and dviewY1 variables. The other corner is set to the same point.
        dviewX1! = X
        dviewY1! = Y
        dviewX2! = dviewX1!
        dviewY2! = dviewY1!
        
'Clip the cursor to the picture control:

        'Get the SCREEN coordinates of the form's origin
        clipP.X = 0
        clipP.Y = 0
        dummy& = ClientToScreen(Me.hWnd, clipP)
        
        'Set the clip rectangle
        clipR.Top = pctScreen.Top + clipP.Y ' Top of pctScreen + top of form
        clipR.Left = pctScreen.Left + clipP.X ' left of pctScreen + left of form, etc.
        clipR.Right = pctScreen.Left + pctScreen.Width + clipP.X
        clipR.Bottom = pctScreen.Top + pctScreen.Height + clipP.Y
        dummy& = ClipCursor&(clipR) ' Clip the cursor to the clipR rectangle
    End If
End Sub


Private Sub pctScreen_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
    If Button And vbLeftButton Then ' If the button is down then
        'Draw mode is XOR. We will draw a second box in the place of the
        'previous one, erasing it.
        pctScreen.Line (dviewX1!, dviewY1!)-(dviewX2!, dviewY2!), QBColor(10), B

        ' Record where we are.
        dviewX2! = X
        dviewY2! = Y
        
        'Draw a dotted box to simulate a dragging rectangle
        pctScreen.Line (dviewX1!, dviewY1!)-(dviewX2!, dviewY2!), QBColor(10), B
    End If
End Sub


Private Sub pctScreen_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
    'Unclip the cursor
    dummy& = ClipCursorBynum&(0&)
    
    'If any of the box's dimensions are 0, then quit
    If dviewX1 = dviewX2 Or dviewY1 = dviewY2 Then Exit Sub
    
    'Erase the box from the screen by re-drawing it.
    pctScreen.Line (dviewX1!, dviewY1!)-(dviewX2!, dviewY2!), QBColor(10), B
    
    'Set the Viewport Variables to the box dimensions
    viewOrgX& = CLng(dviewX1!)
    viewOrgY& = CLng(dviewY1!)
    viewExtX& = CLng(dviewX2!) - CLng(dviewX1!)
    viewExtY& = CLng(dviewY2!) - CLng(dviewY1!)
    
    'Redraw the screen.
    pctScreen.Refresh
End Sub


Private Sub pctScreen_Paint()
    Dim myXform As XFORM, PI As Double, color&
    Dim cosvalue As Double, sinvalue As Double
    
    ' Save the DC in order not to mess up VB drawing functions
    savedDC& = SaveDC&(pctScreen.hdc)
    
    'Make sure the drawing mode is MM_ANISOTROPIC ( no proportions)
    dummy& = SetMapMode&(pctScreen.hdc, MM_ANISOTROPIC)

    If txtRotate.Visible Then ' If we're in NT
        ' Set the graphics mode to advanced (Enable transformations)
        dummy& = SetGraphicsMode&(pctScreen.hdc, GM_ADVANCED)

        If RotAngle% = 0 Then ' No rotate
            dummy& = ModifyWorldTransform&(pctScreen.hdc, myXform, MWT_IDENTITY)
        Else
            PI = 3.14159265358979
            ' No translation up or down
            myXform.eDx = 0!
            myXform.eDy = 0!

            'Set the matrix to the correct values
            cosvalue = Cos(CDbl(RotAngle%) * PI / CDbl(180))
            sinvalue = Sin(CDbl(RotAngle%) * PI / CDbl(180))
            myXform.eM11 = cosvalue
            myXform.eM12 = sinvalue
            myXform.eM21 = -sinvalue
            myXform.eM22 = cosvalue
            
            ' Enable the transformation
            dummy& = SetWorldTransform&(pctScreen.hdc, myXform)
        End If
    End If

    'Set the Logical Window to the global variables
    dummy& = SetWindowOrgEx&(pctScreen.hdc, WinOrgX&, WinOrgY&, myPoint)
    dummy& = SetWindowExtEx&(pctScreen.hdc, WinExtX&, WinExtY&, mySize)
    
    'Set the viewport
    dummy& = SetViewportOrgEx&(pctScreen.hdc, viewOrgX&, viewOrgY&, myPoint)
    dummy& = SetViewportExtEx&(pctScreen.hdc, viewExtX&, viewExtY&, mySize)
    
    'Make sure drawing mode is NOT xor (see the other Ch. 7 example)
    dummy& = SetROP2&(pctScreen.hdc, R2_COPYPEN)
    
    'Make sure we don't draw dotted.
    pctScreen.DrawStyle = 0 'Solid


    'Draw the rectangle with dimensions specified in global variables
    dummy& = Rectangle&(pctScreen.hdc, RectX1&, RectY1&, RectX2&, RectY2&)
    dummy& = Ellipse&(pctScreen.hdc, RectX1&, RectY1&, RectX2&, RectY2&)
    
    'Draw the Viewport Rectangle in a different color
    color& = pctScreen.ForeColor
    pctScreen.ForeColor = QBColor(11)
    dummy& = Rectangle&(pctScreen.hdc, WinOrgX&, WinOrgY&, _
            WinOrgX& + WinExtX&, WinOrgY& + WinExtY&)
    pctScreen.ForeColor = color&

    'Draw the Window Origin in a different color
    color& = pctScreen.ForeColor
    pctScreen.ForeColor = QBColor(1)
    dummy& = MoveToEx&(pctScreen.hdc, -4&, -4&, myPoint)
    dummy& = LineTo&(pctScreen.hdc, 4&, 4&)
    dummy& = MoveToEx&(pctScreen.hdc, -4&, 4&, myPoint)
    dummy& = LineTo&(pctScreen.hdc, 4&, -4&)
    pctScreen.ForeColor = color&
    
    
    'Restore all the changed settings.
    pctScreen.DrawStyle = 2 'Dot
    dummy& = RestoreDC(pctScreen.hdc, savedDC&)
End Sub


Private Sub txtRotate_Change()
    If txtRotate = "" Then
        txtRotate = "0"
    End If
    If CInt(txtRotate) > 360 Then
        txtRotate = CStr(CInt(txtRotate Mod 360))
    End If
    RotAngle% = CInt(txtRotate)
    pctScreen.Refresh
End Sub

Private Sub txtRotate_KeyPress(KeyAscii As Integer)
    If (KeyAscii < Asc("0") Or KeyAscii > Asc("9")) And KeyAscii <> 8 Then
        KeyAscii = 0
    End If
End Sub


Private Sub txtRotate_LostFocus()
    If txtRotate = "" Then
        txtRotate = "0"
    End If
    If CInt(txtRotate) > 360 Then
        txtRotate = CStr(CInt(txtRotate Mod 360))
    End If
    RotAngle% = CInt(txtRotate)
End Sub


