VERSION 5.00
Begin VB.Form frmIcon 
   Caption         =   "Icon Shading"
   ClientHeight    =   1395
   ClientLeft      =   1710
   ClientTop       =   2055
   ClientWidth     =   2685
   LinkTopic       =   "Form1"
   PaletteMode     =   1  'UseZOrder
   ScaleHeight     =   93
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   179
   Begin VB.PictureBox pctFlag 
      BackColor       =   &H000000FF&
      Height          =   555
      Index           =   1
      Left            =   960
      Picture         =   "Shade.frx":0000
      ScaleHeight     =   35
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   35
      TabIndex        =   2
      Top             =   60
      Width           =   555
   End
   Begin VB.PictureBox pctFlag 
      BackColor       =   &H0000FF00&
      Height          =   555
      Index           =   2
      Left            =   1800
      Picture         =   "Shade.frx":030A
      ScaleHeight     =   35
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   35
      TabIndex        =   1
      Top             =   60
      Width           =   555
   End
   Begin VB.PictureBox pctFlag 
      BackColor       =   &H00FF0000&
      Height          =   555
      Index           =   0
      Left            =   120
      Picture         =   "Shade.frx":0614
      ScaleHeight     =   35
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   35
      TabIndex        =   0
      Top             =   60
      Width           =   555
   End
   Begin VB.Label lblText 
      Caption         =   "Choose an icon and watch how  the selected icon gets the Windows95 ""Selected Icon"" look."
      Height          =   615
      Left            =   120
      TabIndex        =   3
      Top             =   720
      Width           =   2415
      WordWrap        =   -1  'True
   End
End
Attribute VB_Name = "frmIcon"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
' Copyright  1997 by Desaware Inc. All Rights Reserved

'**********************************
'**  Type Definitions:

#If Win32 Then
Private Type RECT
        left As Long
        top As Long
        right As Long
        bottom As Long
End Type

#End If 'WIN32 Types

'**********************************
'**  Constant Definitions:

#If Win32 Then
Private Const OPAQUE& = 2
Private Const SRCAND& = &H8800C6
Private Const SRCCOPY& = &HCC0020
Private Const SRCERASE& = &H440328
Private Const SRCINVERT& = &H660046
Private Const DSTINVERT& = &H550009
Private Const SRCPAINT& = &HEE0086
Private Const COLOR_HIGHLIGHT& = 13
Private Const WHITENESS& = &HFF0062
Private Const BLACKNESS& = &H42
#End If 'WIN32

'**********************************
'**  Function Declarations:

#If Win32 Then
Private Declare Function DrawIcon& Lib "user32" (ByVal hDC As Long, ByVal x As Long, ByVal y As Long, ByVal hIcon As Long)
Private Declare Function CreateBitmap& Lib "gdi32" (ByVal nWidth As Long, ByVal nHeight As Long, ByVal nPlanes As Long, ByVal nBitCount As Long, lpBits As Any)
Private Declare Function CreateCompatibleBitmap& Lib "gdi32" (ByVal hDC As Long, ByVal nWidth As Long, ByVal nHeight As Long)
Private Declare Function CreateCompatibleDC& Lib "gdi32" (ByVal hDC As Long)
Private Declare Function CreatePatternBrush& Lib "gdi32" (ByVal hBitmap As Long)
Private Declare Function SelectObject& Lib "gdi32" (ByVal hDC As Long, ByVal hObject As Long)
Private Declare Function DeleteDC& Lib "gdi32" (ByVal hDC As Long)
Private Declare Function DeleteObject& Lib "gdi32" (ByVal hObject As Long)
Private Declare Function FillRect& Lib "user32" (ByVal hDC As Long, lpRect As RECT, ByVal hBrush As Long)
Private Declare Function BitBlt& Lib "gdi32" (ByVal hDestDC As Long, ByVal x As Long, ByVal y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, ByVal XSrc As Long, ByVal YSrc As Long, ByVal dwRop As Long)
Private Declare Function PatBlt& Lib "gdi32" (ByVal hDestDC As Long, ByVal x As Long, ByVal y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal Pattern As Long)
Private Declare Function GetSysColor& Lib "user32" (ByVal nIndex As Long)
Private Declare Function SetBkColor& Lib "gdi32" (ByVal hDC As Long, ByVal crColor As Long)
Private Declare Function SetTextColor& Lib "gdi32" (ByVal hDC As Long, ByVal crColor As Long)
Private Declare Function SetBkMode& Lib "gdi32" (ByVal hDC As Long, ByVal nBkMode As Long)
Private Declare Function GetDesktopWindow& Lib "user32" ()
Private Declare Function GetDC& Lib "user32" (ByVal hwnd As Long)
Private Declare Function UpdateWindow& Lib "user32" (ByVal hwnd As Long)
Private Declare Function CreateDC& Lib "gdi32" Alias "CreateDCA" (ByVal lpDriverName As String, ByVal lpDeviceName As Long, ByVal lpOutput As Long, lpInitData As Long)
#End If 'WIN32

Private Sub ShadeRect(ByVal hDC As Long, lpRect As RECT)
    Dim crHiColor&, crOldBkColor&, crOldTextColor&
    Dim hBrush&, hOldBrush&
    Dim hBitmap&, hBitmap2&
    Dim hBrushBitmap&, hOldMemBitmap&
    Dim oldBkMode&, nWidth&, nHeight&
    Dim hMemDC&
    Dim rcRect As RECT
    Dim Bits(7) As Integer
    Dim i%, dl&
    
    For i% = 0 To 6 Step 2
        Bits(i%) = &H55
        Bits(i% + 1) = &HAA
    Next i%
    nHeight = lpRect.bottom - lpRect.top
    nWidth = lpRect.right - lpRect.left
    
    hBrushBitmap = CreateBitmap(8, 8, 1, 1, Bits(0))
    hBrush = CreatePatternBrush(hBrushBitmap)
    
    hBitmap = CreateCompatibleBitmap(hDC, nWidth, nHeight)
    hMemDC = CreateCompatibleDC(hDC)
    
    hOldMemBitmap = SelectObject(hMemDC, hBitmap)
    
    rcRect.right = nWidth
    rcRect.bottom = nHeight

    dl& = FillRect(hMemDC, rcRect, hBrush)
    dl& = BitBlt(hMemDC, 0, 0, nWidth, nHeight, hDC, lpRect.left, lpRect.top, SRCAND)
    
    crOldTextColor = SetTextColor(hDC, 0)
    crOldBkColor = SetBkColor(hDC, RGB(0, 0, 0))
    dl& = SetBkMode(hDC, OPAQUE)
    
    hOldBrush = SelectObject(hDC, hBrush)
    dl& = FillRect(hDC, lpRect, hBrush)
    dl& = BitBlt(hDC, lpRect.left, lpRect.top, nWidth, nHeight, hMemDC, 0, 0, SRCPAINT)
    

    dl& = SetBkMode(hDC, oldBkMode)
    dl& = SetBkColor(hDC, crOldBkColor)
    dl& = SetTextColor(hDC, crOldTextColor)

    dl& = SelectObject(hMemDC, hOldMemBitmap)
    dl& = DeleteObject(hBitmap)
    dl& = DeleteDC(hMemDC)
    
    dl& = DeleteObject(hBrushBitmap)
    dl& = SelectObject(hDC, hOldBrush)
    dl& = DeleteObject(hBrush)
    
End Sub




Private Sub Form_Click()
    Dim desktop&, myRect As RECT, dl&, i%
    Exit Sub
    myRect.left = 0
    myRect.top = 0
    myRect.right = 1000
    myRect.bottom = 1000
    dl& = CreateDC("DISPLAY", 0, 0, 0)
    ShadeRect dl&, myRect
    MsgBox "BLAH"
'    dl& = PatBlt&(dl&, 0, 0, 1000, 1000, WHITENESS)
    DeleteDC (dl&)
End Sub

Private Sub lblText_Click()
    Form_Click
End Sub


Private Sub pctFlag_Click(Index As Integer)
    Dim i%
    For i% = 0 To 2
        pctFlag(i%).Refresh
    Next i%
    ShadeIcon pctFlag(Index).hDC, pctFlag(Index).Picture
End Sub
Private Function ShadeIcon(ByVal hDC As Long, hIcon As Long)
    Dim crHiColor&, crOldBkColor&, crOldTextColor&
    Dim hBrush&, hOldBrush&
    Dim hBitmap&, hBitmap2&
    Dim hBrushBitmap&, hOldMemBitmap&
    Dim oldBkMode&, nWidth&, nHeight&
    Dim hMemDC&, hMemDC2&
    Dim hMaskDC&, hMaskDC2&, hMaskBitmap&, hMaskBitmap2&
    Dim rcRect As RECT
    Dim Bits(7) As Integer
    Dim i%, dl&

    For i% = 0 To 6 Step 2
        Bits(i%) = &H55
        Bits(i% + 1) = &HAA
    Next i%
    nWidth = 32
    nHeight = 32

    hBrushBitmap = CreateBitmap(8, 8, 1, 1, Bits(0))
    hBrush = CreatePatternBrush(hBrushBitmap)

    hBitmap = CreateCompatibleBitmap(hDC, nWidth, nHeight)
    hBitmap2 = CreateCompatibleBitmap(hDC, nWidth, nHeight)
    hMemDC = CreateCompatibleDC(hDC)
    hMemDC2 = CreateCompatibleDC(hDC)
    dl& = BitBlt(hMemDC2, 0, 0, nWidth, nHeight, hDC, 0, 0, SRCCOPY)


    hOldMemBitmap = SelectObject(hMemDC, hBitmap)
    dl& = SelectObject(hMemDC2, hBitmap2)

    rcRect.right = nWidth
    rcRect.bottom = nHeight

    dl& = FillRect(hMemDC, rcRect, hBrush)
    dl& = BitBlt(hMemDC, 0, 0, nWidth, nHeight, hDC, 0, 0, SRCAND)

    crOldTextColor = SetTextColor(hMemDC2, GetSysColor(COLOR_HIGHLIGHT))
    crOldBkColor = SetBkColor(hMemDC2, RGB(0, 0, 0))
    dl& = SetBkMode(hMemDC2, OPAQUE)

    hOldBrush = SelectObject(hDC, hBrush)
    dl& = FillRect(hMemDC2, rcRect, hBrush)
    dl& = BitBlt(hMemDC2, 0, 0, nWidth, nHeight, hMemDC, 0, 0, SRCPAINT)

    hMaskDC = CreateCompatibleDC(hDC)
    hMaskDC2 = CreateCompatibleDC(hDC)

    hMaskBitmap = CreateCompatibleBitmap(hDC, 32, 32)
    hMaskBitmap2 = CreateCompatibleBitmap(hDC, 32, 32)

    dl& = SelectObject(hMaskDC, hMaskBitmap)
    dl& = SelectObject(hMaskDC2, hMaskBitmap2)

    dl& = PatBlt(hMaskDC, 0, 0, 32, 32, WHITENESS)
    dl& = PatBlt(hMaskDC2, 0, 0, 32, 32, BLACKNESS)
    dl& = DrawIcon(hMaskDC, 0, 0, hIcon)
    dl& = DrawIcon(hMaskDC2, 0, 0, hIcon)
    dl& = BitBlt(hMaskDC, 0, 0, 32, 32, hMaskDC2, 0, 0, SRCINVERT)
    dl& = BitBlt(hDC, 0, 0, 32, 32, hMaskDC, 0, 0, SRCAND)
    dl& = BitBlt(hMaskDC, 0, 0, 32, 32, hMaskDC, 0, 0, DSTINVERT)
    dl& = BitBlt(hMaskDC2, 0, 0, 32, 32, hMemDC, 0, 0, SRCCOPY)
    dl& = BitBlt(hMaskDC2, 0, 0, 32, 32, hMaskDC, 0, 0, SRCAND)
    dl& = BitBlt(hDC, 0, 0, 32, 32, hMaskDC2, 0, 0, SRCPAINT)

    dl& = SetBkMode(hDC, oldBkMode)
    dl& = SetBkColor(hDC, crOldBkColor)
    dl& = SetTextColor(hDC, crOldTextColor)

    dl& = SelectObject(hMemDC, hOldMemBitmap)
    dl& = DeleteObject(hBitmap)
    dl& = DeleteObject(hBitmap2)
    dl& = DeleteDC(hMemDC)
    dl& = DeleteDC(hMemDC2)

    dl& = DeleteDC(hMaskDC)
    dl& = DeleteDC(hMaskDC2)
    dl& = DeleteObject(hMaskBitmap)
    dl& = DeleteObject(hMaskBitmap2)

    dl& = DeleteObject(hBrushBitmap)
    dl& = SelectObject(hDC, hOldBrush)
    dl& = DeleteObject(hBrush)

End Function






