VERSION 5.00
Begin VB.Form frmResource 
   Caption         =   "Resource Browser"
   ClientHeight    =   3900
   ClientLeft      =   1095
   ClientTop       =   1515
   ClientWidth     =   5025
   LinkTopic       =   "Form1"
   PaletteMode     =   1  'UseZOrder
   ScaleHeight     =   3900
   ScaleWidth      =   5025
   Begin VB.ListBox lstNames 
      Height          =   1590
      Left            =   2520
      TabIndex        =   4
      Top             =   2220
      Width           =   2235
   End
   Begin VB.ListBox lstTypes 
      Height          =   1590
      Left            =   180
      TabIndex        =   3
      Top             =   2220
      Width           =   2175
   End
   Begin VB.FileListBox File1 
      Height          =   1590
      Left            =   2520
      TabIndex        =   2
      Top             =   180
      Width           =   2235
   End
   Begin VB.DirListBox Dir1 
      Height          =   1155
      Left            =   180
      TabIndex        =   1
      Top             =   600
      Width           =   2175
   End
   Begin VB.DriveListBox Drive1 
      Height          =   315
      Left            =   180
      TabIndex        =   0
      Top             =   180
      Width           =   2175
   End
End
Attribute VB_Name = "frmResource"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' Note - Only sees resources for 32 bit files.

Option Explicit
' Copyright  1997 by Desaware Inc. All Rights Reserved


Private Declare Function LoadLibrary Lib "kernel32" Alias "LoadLibraryA" (ByVal lpLibFileName As String) As Long
Private Declare Function FreeLibrary Lib "kernel32" (ByVal hLibModule As Long) As Long
Private Declare Function EnumResourceNames Lib "kernel32" Alias "EnumResourceNamesA" (ByVal hModule As Long, ByVal lpType As String, ByVal lpEnumFunc As Long, ByVal lParam As Long) As Long
Private Declare Function EnumResourceNamesById Lib "kernel32" Alias "EnumResourceNamesA" (ByVal hModule As Long, ByVal lpType As Long, ByVal lpEnumFunc As Long, ByVal lParam As Long) As Long
Private Declare Function EnumResourceTypes Lib "kernel32" Alias "EnumResourceTypesA" (ByVal hModule As Long, ByVal lpEnumFunc As Long, ByVal lParam As Long) As Long
Private Declare Function LoadLibraryEx Lib "kernel32" Alias "LoadLibraryExA" (ByVal lpLibFileName As String, ByVal hFile As Long, ByVal dwFlags As Long) As Long
Private Const LOAD_LIBRARY_AS_DATAFILE = 2

Dim modulehandle&


Private Sub Dir1_Change()
    File1.Path = Dir1.Path
End Sub

Private Sub Drive1_Change()
    Dir1.Path = Drive1.Drive

End Sub

Private Sub File1_Click()
    Dim res&
    ' Free the previous library if present
    If modulehandle <> 0 Then
        Call FreeLibrary(modulehandle)
    End If
    ' Load in the file into the address space, but don't allow it to
    ' execute (including initialization code).
    modulehandle = LoadLibraryEx(Dir1.Path & "\" & File1.filename, 0, LOAD_LIBRARY_AS_DATAFILE)
    lstTypes.Clear
    lstNames.Clear
    ' Start by enumerating the types of resources in the file
    If modulehandle <> 0 Then res = EnumResourceTypes(modulehandle, AddressOf Callback1_cbxLLL, 0)
    
End Sub

Private Sub Form_Unload(Cancel As Integer)
    ' Clean up when done.
    If modulehandle <> 0 Then
        Call FreeLibrary(modulehandle)
    End If

End Sub

Private Sub lstTypes_Click()
    Dim usetype&
    Dim res&
    Dim usestring$
    If lstTypes.ListCount = 0 Or modulehandle = 0 Then Exit Sub
    usetype = lstTypes.ItemData(lstTypes.ListIndex)
    lstNames.Clear
    ' We have two aliases for the EnumResourceNames function, one which
    ' takes a numeric resource type, the other which takes a
    ' resource type string
    If usetype = 0 Then
        usestring = lstTypes.List(lstTypes.ListIndex)
        res = EnumResourceNames(modulehandle, usestring, AddressOf cbkNames_cbxLLLL, 0)
    Else
        res = EnumResourceNamesById(modulehandle, usetype, AddressOf cbkNames_cbxLLLL, 0)
    End If
End Sub
