VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "dwNetError"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
' Class dwNetError
' Copyright (c) 1996 by Desaware Inc.  All Rights Reserved
' Part of the Desaware API Class Library
' For further information contact:
' Desaware Inc.
' 1100 E. Hamilton Ave.  Suite #4
' Campbell, CA 95008
' (408) 377-4770
' www.desaware.com


Option Explicit

Private Declare Function WNetGetLastError Lib "mpr.dll" Alias "WNetGetLastErrorA" (lpError As Long, ByVal lpErrorBuf As String, ByVal nErrorBufSize As Long, ByVal lpNameBuf As String, ByVal nNameBufSize As Long) As Long


' These values can be set, but it's pointless
' they are intended only to be read

Public dwErrorCode&   ' Network specific error code
Public szDescription$ ' Description of the error
Public szName$        ' Name of the network provider

Private Sub Class_Initialize()
   ' Preinitialize the strings (as always)
   szDescription = String$(512, 0)
   szName = String$(512, 0)
   Call WNetGetLastError(dwErrorCode, szDescription, 511, szName, 511)
   ' Strip off everything after the null terminator
   szDescription = agGetStringFromLPSTR(szDescription)
   szName = agGetStringFromLPSTR(szName)
End Sub
