VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "dwRemoteNameInfo"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
' Copyright  1997 by Desaware Inc. All Rights Reserved

Private Type REMOTE_NAME_INFO
   lpUniversalName As Long
   lpConnectionName As Long
   lpRemainingPath As Long
End Type

Public lpUniversalName As String
Public lpConnectionName As String
Public lpRemainingPath As String

Private Declare Function intWNetGetUniversalName Lib "mpr.dll" Alias "WNetGetUniversalNameA" (ByVal lpLocalPath As String, ByVal dwInfoLevel As Long, lpBuffer As Any, lpBufferSize As Long) As Long

' We cheat slightly here, since a UNIVERSAL_NAME_INFO structure is very
' similar to REMOTE_NAME_INFO
Public Function Load(lpLocalPath As String, dwInfoLevel As Long)
   Dim res&
   Dim tbuf()
   Dim BufferSize&
   ReDim tbuf(16384)
   BufferSize = 16384
   Dim Info As REMOTE_NAME_INFO
  
   
   res = intWNetGetUniversalName(lpLocalPath, dwInfoLevel, tbuf(0), BufferSize)
   If res = 0 Then
      agCopyData tbuf(0), Info, Len(Info)
      lpUniversalName = agGetStringFromPointer(Info.lpUniversalName)
      If dwInfoLevel = REMOTE_NAME_INFO_LEVEL Then
         lpConnectionName = agGetStringFromPointer(Info.lpConnectionName)
         lpRemainingPath = agGetStringFromPointer(Info.lpRemainingPath)
      End If
   End If
   ' We'll leave it for the parent to do the LastError stuff
   Load = res
End Function
